=== debian/changelog ===
atlas-ecmwf (0.19.0-8build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:33:35 +0100

atlas-ecmwf (0.19.0-8) unstable; urgency=medium

  * Fix cut/paste error in unsigned-long.patch that breaks on 32-bit archs

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 13 Jan 2020 14:05:58 +0000

atlas-ecmwf (0.19.0-7) unstable; urgency=medium

  * Ensure ENNABLE_32_BIT_HOST is set on 32-bit archs in d/rules
  * unsigned-long.patch: make changes conditional on ATLAS_BITS_GLOBAL==64

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 10 Jan 2020 11:47:23 +0000

atlas-ecmwf (0.19.0-6) unstable; urgency=medium

  * Add libcgal-dev as Depedency of -dev package
  * Drop libcgal-dev dependency on armel, where is currently FTBFS
  * unsigned-long.patch: Drop support for unsigned longs, as it breaks
    32-bit systems (better fix needed)

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Jan 2020 15:25:35 +0000

atlas-ecmwf (0.19.0-5) unstable; urgency=medium

  * size_t patch for 32-bit systems compile
  * Disable tests for this release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Jan 2020 07:21:24 +0000

atlas-ecmwf (0.19.0-4) unstable; urgency=medium

  * Build-dep on libeckit-dev (>= 1.4.7-7 ) as it now pulls
    in libaec-dev needed to build
  * Drop our dependencies on :libssl-dev, libcurl4-gnutls-dev,
    libxxhash-dev, libsnappy-dev, liblz4-dev, libbz2-dev ;
    pulled in by libeckit-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Jan 2020 07:13:48 +0000

atlas-ecmwf (0.19.0-3) unstable; urgency=medium

  * Install includes in correct directory in -dev pkg
  * Enable proj support
  * Drop Dependency on gridtools-dev until we build against it properly
  * Change paths in cmake files to match installed locations
  * Add eckt, eigen3 dependencies to -dev pkg as needed to build with cmake
  * Add Breaks/Replaces for files that moved from metview* -> atlas

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 07 Jan 2020 10:30:36 +0000

atlas-ecmwf (0.19.0-2) unstable; urgency=medium

  * Build without Fortran support until fckit is in archive.
  * Build-depend on libcgal-dev for tesselation; on latex for docs
  * Build-depend on libssl-dev, libcurl4-gnutls-dev, libxxhash-dev, 
    libsnappy-dev, liblz4-dev, libbz2-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 04 Jan 2020 08:54:31 +0000

atlas-ecmwf (0.19.0-1) unstable; urgency=medium

  * Initial release. (Closes: #942635)

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 01 Jan 2020 15:09:43 +0000
